abstract class Writer {
  abstract def write(msg)
}

class StringWriter extends Writer {
  def target = new StringBuilder()
  def write(msg) {
    target.append(msg)
  }
  String toString() { target.toString() }
}

def writeStuff(writer) {
  writer.write("This is stupid")
  println writer
}

Object.metaClass.invokeOnPreviousMixin = { 
  MetaClass currentMixinMetaClass, String method, Object[] args ->

  def previousMixin = delegate.getClass()

  for(mixin in mixedIn.mixinClasses) {
    if(mixin.mixinClass.theClass == 
      currentMixinMetaClass.delegate.theClass) break
    previousMixin = mixin.mixinClass.theClass
  }

  mixedIn[previousMixin]."$method"(*args)  
}

class UppercaseFilter {
  def write(msg) {
    def intermediateResult = msg.toUpperCase()
    invokeOnPreviousMixin(
      metaClass, "write",
      intermediateResult)
  }
}

class ProfanityFilter {
  def write(msg) {
    def result = msg.replace("stupid", "s*****")
    invokeOnPreviousMixin(metaClass, "write", result)
  }
}

def createStringWriter(Object[] filters) {
  def instance = new StringWriter()
  filters.each { filter ->
    instance.metaClass.mixin filter
  }
  instance
}

writeStuff(createStringWriter())
writeStuff(createStringWriter(UppercaseFilter))
writeStuff(createStringWriter(ProfanityFilter))
writeStuff(createStringWriter(
  UppercaseFilter, ProfanityFilter
))
writeStuff(createStringWriter(
  ProfanityFilter, UppercaseFilter
))